> ## Documentation Index
> Fetch the complete documentation index at: https://docs.asteroid.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Retrieve execution activities

> Get activities for an execution



## OpenAPI

````yaml https://odyssey.asteroid.ai/agents/v2/openapi.yaml get /executions/{executionId}/activities
openapi: 3.1.0
info:
  title: Agent Service
  version: v1
servers:
  - description: V2 API
    url: https://odyssey.asteroid.ai/agents/v2
security:
  - ApiKeyAuth: []
tags:
  - name: Agents
  - name: Execution
  - name: Files
  - name: Agent Profiles
  - name: Agent Profile Pools
  - name: Workflows
  - name: Schema
  - name: Documentation
  - name: Context
paths:
  /executions/{executionId}/activities:
    get:
      tags:
        - Execution
      summary: Retrieve execution activities
      description: Get activities for an execution
      operationId: ExecutionActivitiesGet
      parameters:
        - description: The unique identifier of the execution
          in: path
          name: executionId
          required: true
          schema:
            $ref: '#/components/schemas/Common.uuid'
        - description: Sort order for activities by timestamp
          explode: false
          in: query
          name: order
          schema:
            enum:
              - asc
              - desc
            type: string
        - description: Maximum number of activities to return
          explode: false
          in: query
          name: limit
          schema:
            format: int32
            type: integer
      responses:
        '200':
          content:
            application/json:
              schema:
                items:
                  $ref: '#/components/schemas/Agents.Execution.Activity'
                type: array
          description: The request has succeeded.
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Common.BadRequestErrorBody'
          description: The server could not understand the request due to invalid syntax.
        '401':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Common.UnauthorizedErrorBody'
          description: Access is unauthorized.
        '403':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Common.ForbiddenErrorBody'
          description: Access is forbidden.
        '404':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Common.NotFoundErrorBody'
          description: The server cannot find the requested resource.
        '500':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Common.InternalServerErrorBody'
          description: Server error
components:
  schemas:
    Common.uuid:
      format: uuid
      type: string
    Agents.Execution.Activity:
      properties:
        executionId:
          $ref: '#/components/schemas/Common.uuid'
        id:
          $ref: '#/components/schemas/Common.uuid'
        payload:
          $ref: '#/components/schemas/Agents.Execution.ActivityPayloadUnion'
        timestamp:
          format: date-time
          type: string
      required:
        - id
        - payload
        - executionId
        - timestamp
      type: object
    Common.BadRequestErrorBody:
      properties:
        code:
          enum:
            - 400
          type: number
          x-enum-varnames:
            - BadRequest
        message:
          type: string
      required:
        - code
        - message
      type: object
    Common.UnauthorizedErrorBody:
      properties:
        code:
          enum:
            - 401
          type: number
          x-enum-varnames:
            - Unauthorized
        message:
          type: string
      required:
        - code
        - message
      type: object
    Common.ForbiddenErrorBody:
      properties:
        code:
          enum:
            - 403
          type: number
          x-enum-varnames:
            - Forbidden
        message:
          type: string
      required:
        - code
        - message
      type: object
    Common.NotFoundErrorBody:
      properties:
        code:
          enum:
            - 404
          type: number
          x-enum-varnames:
            - NotFound
        message:
          type: string
      required:
        - code
        - message
      type: object
    Common.InternalServerErrorBody:
      properties:
        code:
          enum:
            - 500
          type: number
          x-enum-varnames:
            - InternalServerError
        message:
          type: string
      required:
        - code
        - message
      type: object
    Agents.Execution.ActivityPayloadUnion:
      discriminator:
        mapping:
          action_completed:
            $ref: >-
              #/components/schemas/Agents.Execution.ActivityActionCompletedPayload
          action_failed:
            $ref: '#/components/schemas/Agents.Execution.ActivityActionFailedPayload'
          action_started:
            $ref: '#/components/schemas/Agents.Execution.ActivityActionStartedPayload'
          compaction_performed:
            $ref: >-
              #/components/schemas/Agents.Execution.ActivityCompactionPerformedPayload
          compaction_started:
            $ref: >-
              #/components/schemas/Agents.Execution.ActivityCompactionStartedPayload
          file_added:
            $ref: '#/components/schemas/Agents.Execution.ActivityFileAddedPayload'
          generic:
            $ref: '#/components/schemas/Agents.Execution.ActivityGenericPayload'
          playwright_script_generated:
            $ref: >-
              #/components/schemas/Agents.Execution.ActivityPlaywrightScriptGeneratedPayload
          reasoning:
            $ref: '#/components/schemas/Agents.Execution.ActivityReasoningPayload'
          script_variables_substituted:
            $ref: >-
              #/components/schemas/Agents.Execution.ActivityScriptVariablesSubstitutedPayload
          status_changed:
            $ref: '#/components/schemas/Agents.Execution.ActivityStatusChangedPayload'
          step_completed:
            $ref: '#/components/schemas/Agents.Execution.ActivityStepCompletedPayload'
          step_started:
            $ref: '#/components/schemas/Agents.Execution.ActivityStepStartedPayload'
          terminal:
            $ref: '#/components/schemas/Agents.Execution.TerminalPayload'
          todos_updated:
            $ref: '#/components/schemas/Agents.Execution.ActivityTodosUpdatedPayload'
          transitioned_node:
            $ref: >-
              #/components/schemas/Agents.Execution.ActivityTransitionedNodePayload
          user_message_received:
            $ref: >-
              #/components/schemas/Agents.Execution.ActivityUserMessageReceivedPayload
          workflow_updated:
            $ref: >-
              #/components/schemas/Agents.Execution.ActivityWorkflowUpdatedPayload
        propertyName: activityType
      oneOf:
        - $ref: '#/components/schemas/Agents.Execution.TerminalPayload'
        - $ref: '#/components/schemas/Agents.Execution.ActivityGenericPayload'
        - $ref: '#/components/schemas/Agents.Execution.ActivityReasoningPayload'
        - $ref: >-
            #/components/schemas/Agents.Execution.ActivityCompactionStartedPayload
        - $ref: >-
            #/components/schemas/Agents.Execution.ActivityCompactionPerformedPayload
        - $ref: '#/components/schemas/Agents.Execution.ActivityStepStartedPayload'
        - $ref: '#/components/schemas/Agents.Execution.ActivityStepCompletedPayload'
        - $ref: >-
            #/components/schemas/Agents.Execution.ActivityTransitionedNodePayload
        - $ref: '#/components/schemas/Agents.Execution.ActivityStatusChangedPayload'
        - $ref: '#/components/schemas/Agents.Execution.ActivityActionStartedPayload'
        - $ref: '#/components/schemas/Agents.Execution.ActivityActionCompletedPayload'
        - $ref: '#/components/schemas/Agents.Execution.ActivityActionFailedPayload'
        - $ref: >-
            #/components/schemas/Agents.Execution.ActivityUserMessageReceivedPayload
        - $ref: '#/components/schemas/Agents.Execution.ActivityFileAddedPayload'
        - $ref: '#/components/schemas/Agents.Execution.ActivityWorkflowUpdatedPayload'
        - $ref: >-
            #/components/schemas/Agents.Execution.ActivityPlaywrightScriptGeneratedPayload
        - $ref: >-
            #/components/schemas/Agents.Execution.ActivityScriptVariablesSubstitutedPayload
        - $ref: '#/components/schemas/Agents.Execution.ActivityTodosUpdatedPayload'
      type: object
    Agents.Execution.ActivityActionCompletedPayload:
      properties:
        actionId:
          type: string
        actionName:
          $ref: '#/components/schemas/Agents.Execution.ActionName'
        activityType:
          enum:
            - action_completed
          type: string
        display:
          $ref: '#/components/schemas/Agents.Execution.ActivityDisplay'
        duration:
          format: int64
          type: integer
        info:
          $ref: '#/components/schemas/Agents.Execution.ActivityActionCompletedInfo'
        message:
          type: string
      required:
        - activityType
        - message
        - actionId
        - actionName
      type: object
    Agents.Execution.ActivityActionFailedPayload:
      properties:
        actionId:
          type: string
        actionName:
          $ref: '#/components/schemas/Agents.Execution.ActionName'
        activityType:
          enum:
            - action_failed
          type: string
        display:
          $ref: '#/components/schemas/Agents.Execution.ActivityDisplay'
        duration:
          format: int64
          type: integer
        message:
          type: string
      required:
        - activityType
        - message
        - actionName
        - actionId
      type: object
    Agents.Execution.ActivityActionStartedPayload:
      properties:
        actionId:
          type: string
        actionName:
          $ref: '#/components/schemas/Agents.Execution.ActionName'
        activityType:
          enum:
            - action_started
          type: string
        display:
          $ref: '#/components/schemas/Agents.Execution.ActivityDisplay'
        info:
          $ref: '#/components/schemas/Agents.Execution.ActivityActionStartedInfo'
        message:
          type: string
      required:
        - activityType
        - message
        - actionName
        - actionId
      type: object
    Agents.Execution.ActivityCompactionPerformedPayload:
      properties:
        activityType:
          enum:
            - compaction_performed
          type: string
        display:
          $ref: '#/components/schemas/Agents.Execution.ActivityDisplay'
        durationMs:
          type: integer
        summaryTokens:
          type: integer
      required:
        - activityType
        - summaryTokens
        - durationMs
      type: object
    Agents.Execution.ActivityCompactionStartedPayload:
      properties:
        activityType:
          enum:
            - compaction_started
          type: string
        display:
          $ref: '#/components/schemas/Agents.Execution.ActivityDisplay'
      required:
        - activityType
      type: object
    Agents.Execution.ActivityFileAddedPayload:
      properties:
        activityType:
          enum:
            - file_added
          type: string
        fileId:
          $ref: '#/components/schemas/Common.uuid'
        fileName:
          type: string
        fileSize:
          format: int32
          type: integer
        mimeType:
          type: string
        presignedUrl:
          type: string
        source:
          enum:
            - upload
            - download
            - agent
          type: string
      required:
        - activityType
        - fileId
        - fileName
        - mimeType
        - fileSize
        - source
        - presignedUrl
      type: object
    Agents.Execution.ActivityGenericPayload:
      properties:
        activityType:
          enum:
            - generic
          type: string
        display:
          $ref: '#/components/schemas/Agents.Execution.ActivityDisplay'
        message:
          type: string
      required:
        - activityType
        - message
      type: object
    Agents.Execution.ActivityPlaywrightScriptGeneratedPayload:
      properties:
        activityType:
          enum:
            - playwright_script_generated
          type: string
        context:
          type: string
        llmVars:
          items:
            $ref: >-
              #/components/schemas/Agents.Graph.Models.Nodes.Properties.PlaywrightScriptLLMVar
          type: array
        nodeId:
          $ref: '#/components/schemas/Common.uuid'
        nodeName:
          type: string
        oldScript:
          type: string
        script:
          type: string
      required:
        - activityType
        - nodeId
        - nodeName
        - script
        - context
      type: object
    Agents.Execution.ActivityReasoningPayload:
      properties:
        activityType:
          enum:
            - reasoning
          type: string
        display:
          $ref: '#/components/schemas/Agents.Execution.ActivityDisplay'
        reasoning:
          type: string
      required:
        - activityType
        - reasoning
      type: object
    Agents.Execution.ActivityScriptVariablesSubstitutedPayload:
      properties:
        activityType:
          enum:
            - script_variables_substituted
          type: string
        display:
          $ref: '#/components/schemas/Agents.Execution.ActivityDisplay'
        nodeId:
          $ref: '#/components/schemas/Common.uuid'
        nodeName:
          type: string
        placeholders:
          items:
            type: string
          type: array
        scriptFileName:
          type: string
        substituted:
          type: boolean
        variables:
          type: object
          unevaluatedProperties:
            type: string
      required:
        - activityType
        - nodeId
        - nodeName
        - scriptFileName
        - placeholders
        - variables
        - substituted
      type: object
    Agents.Execution.ActivityStatusChangedPayload:
      properties:
        activityType:
          enum:
            - status_changed
          type: string
        awaitingConfirmationPayload:
          $ref: '#/components/schemas/Agents.Execution.AwaitingConfirmationPayload'
        cancelledPayload:
          $ref: '#/components/schemas/Agents.Execution.CancelledPayload'
        completedPayload:
          $ref: '#/components/schemas/Agents.Execution.CompletedPayload'
        failedPayload:
          $ref: '#/components/schemas/Agents.Execution.FailedPayload'
        pausedPayload:
          $ref: '#/components/schemas/Agents.Execution.PausedPayload'
        status:
          $ref: '#/components/schemas/Agents.Execution.Status'
      required:
        - activityType
        - status
      type: object
    Agents.Execution.ActivityStepCompletedPayload:
      properties:
        activityType:
          enum:
            - step_completed
          type: string
        stepNumber:
          format: int64
          type: integer
      required:
        - activityType
        - stepNumber
      type: object
    Agents.Execution.ActivityStepStartedPayload:
      properties:
        activityType:
          enum:
            - step_started
          type: string
        stepNumber:
          format: int64
          type: integer
      required:
        - activityType
        - stepNumber
      type: object
    Agents.Execution.TerminalPayload:
      properties:
        activityType:
          enum:
            - terminal
          type: string
        message:
          type: string
        reason:
          enum:
            - unsubscribe
            - complete
            - error
          type: string
      required:
        - activityType
        - reason
      type: object
    Agents.Execution.ActivityTodosUpdatedPayload:
      properties:
        activityType:
          enum:
            - todos_updated
          type: string
        display:
          $ref: '#/components/schemas/Agents.Execution.ActivityDisplay'
        todos:
          items:
            $ref: '#/components/schemas/Agents.Execution.Todo'
          type: array
      required:
        - activityType
        - todos
      type: object
    Agents.Execution.ActivityTransitionedNodePayload:
      properties:
        activityType:
          enum:
            - transitioned_node
          type: string
        fromNodeDuration:
          format: int32
          type: integer
        fromNodeOutput:
          description: Output variables provided by the from node
          items:
            $ref: '#/components/schemas/Agents.Execution.NodeOutputItem'
          type: array
        fromNodeSummary:
          description: A summary of the work done in the previous node
          type: string
        newNodeName:
          type: string
        newNodeType:
          type: string
        newNodeUUID:
          $ref: '#/components/schemas/Common.uuid'
        transitionType:
          $ref: '#/components/schemas/Agents.Graph.Models.Transitions.TransitionType'
      required:
        - activityType
        - newNodeUUID
        - newNodeName
        - newNodeType
      type: object
    Agents.Execution.ActivityUserMessageReceivedPayload:
      properties:
        activityType:
          enum:
            - user_message_received
          type: string
        message:
          type: string
        userUUID:
          $ref: '#/components/schemas/Common.uuid'
      required:
        - activityType
        - message
        - userUUID
      type: object
    Agents.Execution.ActivityWorkflowUpdatedPayload:
      properties:
        activityType:
          enum:
            - workflow_updated
          type: string
        workflowUpdate:
          items:
            $ref: '#/components/schemas/Agents.Execution.WorkflowUpdate'
          type: array
      required:
        - activityType
        - workflowUpdate
      type: object
    Agents.Execution.ActionName:
      enum:
        - element_click
        - element_type
        - element_select
        - element_hover
        - element_drag
        - element_wait
        - element_fill_form
        - element_get_text
        - element_file_upload
        - coord_move
        - coord_click
        - coord_double_click
        - coord_triple_click
        - coord_drag
        - coord_scroll
        - nav_to
        - nav_back
        - nav_refresh
        - nav_tabs
        - nav_close_browser
        - nav_resize_browser
        - nav_install_browser
        - nav_zoom_in
        - nav_zoom_out
        - obs_snapshot
        - obs_snapshot_with_selectors
        - obs_screenshot
        - obs_console_messages
        - obs_network_requests
        - obs_extract_html
        - script_eval
        - script_playwright
        - script_playwright_llm_vars
        - script_hybrid_playwright
        - browser_run_code
        - browser_press_key
        - browser_handle_dialog
        - browser_read_clipboard
        - browser_solve_captcha
        - file_list
        - file_read
        - file_stage
        - file_download
        - file_pdf_save
        - scratchpad_read
        - scratchpad_write
        - scriptpad_run_function
        - scriptpad_search_replace
        - scriptpad_read
        - scriptpad_write
        - ext_google_sheets_get_data
        - ext_google_sheets_set_data
        - ext_get_mail
        - ext_send_mail
        - ext_api_call
        - util_wait_time
        - util_get_datetime
        - util_generate_totp_secret
        - util_send_user_message
        - agent_query_context
        - agent_compile_workflow
        - llm_call
        - sdk_bash
        - sdk_read
        - sdk_write
        - sdk_edit
        - sdk_glob
        - sdk_grep
        - handoff_prepare
        - read_file
      type: string
    Agents.Execution.ActivityDisplay:
      properties:
        groupId:
          type: string
        presentationLevel:
          $ref: '#/components/schemas/Agents.Execution.ActivityPresentationLevel'
        summaryText:
          type: string
        turnId:
          type: string
      type: object
    Agents.Execution.ActivityActionCompletedInfo:
      discriminator:
        mapping:
          agent_query_context:
            $ref: >-
              #/components/schemas/Agents.Execution.AgentQueryContextCompletedDetails
          browser_run_code:
            $ref: >-
              #/components/schemas/Agents.Execution.BrowserRunCodeCompletedDetails
          element_file_upload:
            $ref: >-
              #/components/schemas/Agents.Execution.ElementFileUploadCompletedDetails
          ext_api_call:
            $ref: '#/components/schemas/Agents.Execution.ExtApiCallCompletedDetails'
          ext_get_mail:
            $ref: '#/components/schemas/Agents.Execution.ExtGetMailCompletedDetails'
          ext_send_mail:
            $ref: '#/components/schemas/Agents.Execution.ExtSendMailCompletedDetails'
          file_list:
            $ref: '#/components/schemas/Agents.Execution.FileListCompletedDetails'
          file_read:
            $ref: '#/components/schemas/Agents.Execution.FileReadCompletedDetails'
          file_stage:
            $ref: '#/components/schemas/Agents.Execution.FileStageCompletedDetails'
          handoff_prepare:
            $ref: >-
              #/components/schemas/Agents.Execution.HandoffPrepareCompletedDetails
          nav_to:
            $ref: '#/components/schemas/Agents.Execution.NavToCompletedDetails'
          obs_snapshot_with_selectors:
            $ref: >-
              #/components/schemas/Agents.Execution.ObsSnapshotWithSelectorsCompletedDetails
          read_file:
            $ref: '#/components/schemas/Agents.Execution.ReadFileCompletedDetails'
          scratchpad_read:
            $ref: >-
              #/components/schemas/Agents.Execution.ScratchpadReadCompletedDetails
          scratchpad_write:
            $ref: >-
              #/components/schemas/Agents.Execution.ScratchpadWriteCompletedDetails
          script_eval:
            $ref: '#/components/schemas/Agents.Execution.ScriptEvalCompletedDetails'
          script_hybrid_playwright:
            $ref: >-
              #/components/schemas/Agents.Execution.ScriptHybridPlaywrightCompletedDetails
          script_playwright:
            $ref: >-
              #/components/schemas/Agents.Execution.ScriptPlaywrightCompletedDetails
          scriptpad_read:
            $ref: >-
              #/components/schemas/Agents.Execution.ScriptpadReadCompletedDetails
          scriptpad_run_function:
            $ref: >-
              #/components/schemas/Agents.Execution.ScriptPadRunFunctionCompletedDetails
          scriptpad_search_replace:
            $ref: >-
              #/components/schemas/Agents.Execution.ScriptpadSearchReplaceCompletedDetails
          scriptpad_write:
            $ref: >-
              #/components/schemas/Agents.Execution.ScriptpadWriteCompletedDetails
          sdk_bash:
            $ref: '#/components/schemas/Agents.Execution.SdkBashCompletedDetails'
          sdk_edit:
            $ref: '#/components/schemas/Agents.Execution.SdkEditCompletedDetails'
          sdk_glob:
            $ref: '#/components/schemas/Agents.Execution.SdkGlobCompletedDetails'
          sdk_grep:
            $ref: '#/components/schemas/Agents.Execution.SdkGrepCompletedDetails'
          sdk_read:
            $ref: '#/components/schemas/Agents.Execution.SdkReadCompletedDetails'
          sdk_write:
            $ref: '#/components/schemas/Agents.Execution.SdkWriteCompletedDetails'
          util_get_datetime:
            $ref: >-
              #/components/schemas/Agents.Execution.UtilGetDatetimeCompletedDetails
        propertyName: actionName
      oneOf:
        - $ref: '#/components/schemas/Agents.Execution.ExtApiCallCompletedDetails'
        - $ref: '#/components/schemas/Agents.Execution.ScratchpadReadCompletedDetails'
        - $ref: >-
            #/components/schemas/Agents.Execution.ScratchpadWriteCompletedDetails
        - $ref: >-
            #/components/schemas/Agents.Execution.ScriptPlaywrightCompletedDetails
        - $ref: >-
            #/components/schemas/Agents.Execution.ScriptHybridPlaywrightCompletedDetails
        - $ref: '#/components/schemas/Agents.Execution.BrowserRunCodeCompletedDetails'
        - $ref: '#/components/schemas/Agents.Execution.ScriptEvalCompletedDetails'
        - $ref: '#/components/schemas/Agents.Execution.FileReadCompletedDetails'
        - $ref: '#/components/schemas/Agents.Execution.FileListCompletedDetails'
        - $ref: '#/components/schemas/Agents.Execution.FileStageCompletedDetails'
        - $ref: >-
            #/components/schemas/Agents.Execution.ElementFileUploadCompletedDetails
        - $ref: '#/components/schemas/Agents.Execution.ExtGetMailCompletedDetails'
        - $ref: >-
            #/components/schemas/Agents.Execution.ScriptPadRunFunctionCompletedDetails
        - $ref: '#/components/schemas/Agents.Execution.ScriptpadReadCompletedDetails'
        - $ref: '#/components/schemas/Agents.Execution.ScriptpadWriteCompletedDetails'
        - $ref: >-
            #/components/schemas/Agents.Execution.ScriptpadSearchReplaceCompletedDetails
        - $ref: >-
            #/components/schemas/Agents.Execution.ObsSnapshotWithSelectorsCompletedDetails
        - $ref: >-
            #/components/schemas/Agents.Execution.UtilGetDatetimeCompletedDetails
        - $ref: '#/components/schemas/Agents.Execution.NavToCompletedDetails'
        - $ref: >-
            #/components/schemas/Agents.Execution.AgentQueryContextCompletedDetails
        - $ref: '#/components/schemas/Agents.Execution.SdkBashCompletedDetails'
        - $ref: '#/components/schemas/Agents.Execution.SdkReadCompletedDetails'
        - $ref: '#/components/schemas/Agents.Execution.SdkWriteCompletedDetails'
        - $ref: '#/components/schemas/Agents.Execution.SdkEditCompletedDetails'
        - $ref: '#/components/schemas/Agents.Execution.SdkGlobCompletedDetails'
        - $ref: '#/components/schemas/Agents.Execution.SdkGrepCompletedDetails'
        - $ref: '#/components/schemas/Agents.Execution.ReadFileCompletedDetails'
        - $ref: '#/components/schemas/Agents.Execution.HandoffPrepareCompletedDetails'
        - $ref: '#/components/schemas/Agents.Execution.ExtSendMailCompletedDetails'
      type: object
    Agents.Execution.ActivityActionStartedInfo:
      discriminator:
        mapping:
          agent_query_context:
            $ref: >-
              #/components/schemas/Agents.Execution.AgentQueryContextStartedDetails
          browser_run_code:
            $ref: '#/components/schemas/Agents.Execution.BrowserRunCodeStartedDetails'
          ext_send_mail:
            $ref: '#/components/schemas/Agents.Execution.ExtSendMailStartedDetails'
          handoff_prepare:
            $ref: '#/components/schemas/Agents.Execution.HandoffPrepareStartedDetails'
          llm_call:
            $ref: '#/components/schemas/Agents.Execution.LLMCallStartedDetails'
          nav_to:
            $ref: '#/components/schemas/Agents.Execution.NavToStartedDetails'
          read_file:
            $ref: '#/components/schemas/Agents.Execution.ReadFileStartedDetails'
          scratchpad_read:
            $ref: '#/components/schemas/Agents.Execution.ScratchpadReadStartedDetails'
          scratchpad_write:
            $ref: >-
              #/components/schemas/Agents.Execution.ScratchpadWriteStartedDetails
          script_eval:
            $ref: '#/components/schemas/Agents.Execution.ScriptEvalStartedDetails'
          script_hybrid_playwright:
            $ref: >-
              #/components/schemas/Agents.Execution.ScriptHybridPlaywrightStartedDetails
          script_playwright:
            $ref: >-
              #/components/schemas/Agents.Execution.ScriptPlaywrightStartedDetails
          scriptpad_read:
            $ref: '#/components/schemas/Agents.Execution.ScriptpadReadStartedDetails'
          scriptpad_run_function:
            $ref: >-
              #/components/schemas/Agents.Execution.ScriptpadRunFunctionStartedDetails
          scriptpad_search_replace:
            $ref: >-
              #/components/schemas/Agents.Execution.ScriptpadSearchReplaceStartedDetails
          sdk_bash:
            $ref: '#/components/schemas/Agents.Execution.SdkBashStartedDetails'
          sdk_edit:
            $ref: '#/components/schemas/Agents.Execution.SdkEditStartedDetails'
          sdk_glob:
            $ref: '#/components/schemas/Agents.Execution.SdkGlobStartedDetails'
          sdk_grep:
            $ref: '#/components/schemas/Agents.Execution.SdkGrepStartedDetails'
          sdk_read:
            $ref: '#/components/schemas/Agents.Execution.SdkReadStartedDetails'
          sdk_write:
            $ref: '#/components/schemas/Agents.Execution.SdkWriteStartedDetails'
          util_get_datetime:
            $ref: >-
              #/components/schemas/Agents.Execution.UtilGetDatetimeStartedDetails
        propertyName: actionName
      oneOf:
        - $ref: '#/components/schemas/Agents.Execution.NavToStartedDetails'
        - $ref: '#/components/schemas/Agents.Execution.ScratchpadReadStartedDetails'
        - $ref: '#/components/schemas/Agents.Execution.ScratchpadWriteStartedDetails'
        - $ref: >-
            #/components/schemas/Agents.Execution.ScriptpadRunFunctionStartedDetails
        - $ref: '#/components/schemas/Agents.Execution.ScriptPlaywrightStartedDetails'
        - $ref: >-
            #/components/schemas/Agents.Execution.ScriptHybridPlaywrightStartedDetails
        - $ref: '#/components/schemas/Agents.Execution.BrowserRunCodeStartedDetails'
        - $ref: '#/components/schemas/Agents.Execution.ScriptEvalStartedDetails'
        - $ref: >-
            #/components/schemas/Agents.Execution.ScriptpadSearchReplaceStartedDetails
        - $ref: '#/components/schemas/Agents.Execution.UtilGetDatetimeStartedDetails'
        - $ref: '#/components/schemas/Agents.Execution.ScriptpadReadStartedDetails'
        - $ref: '#/components/schemas/Agents.Execution.LLMCallStartedDetails'
        - $ref: >-
            #/components/schemas/Agents.Execution.AgentQueryContextStartedDetails
        - $ref: '#/components/schemas/Agents.Execution.SdkBashStartedDetails'
        - $ref: '#/components/schemas/Agents.Execution.SdkReadStartedDetails'
        - $ref: '#/components/schemas/Agents.Execution.SdkWriteStartedDetails'
        - $ref: '#/components/schemas/Agents.Execution.SdkEditStartedDetails'
        - $ref: '#/components/schemas/Agents.Execution.SdkGlobStartedDetails'
        - $ref: '#/components/schemas/Agents.Execution.SdkGrepStartedDetails'
        - $ref: '#/components/schemas/Agents.Execution.ReadFileStartedDetails'
        - $ref: '#/components/schemas/Agents.Execution.HandoffPrepareStartedDetails'
        - $ref: '#/components/schemas/Agents.Execution.ExtSendMailStartedDetails'
      type: object
    Agents.Graph.Models.Nodes.Properties.PlaywrightScriptLLMVar:
      properties:
        description:
          type: string
        name:
          type: string
        type:
          $ref: >-
            #/components/schemas/Agents.Graph.Models.Nodes.Properties.PlaywrightScriptLLMVarType
      required:
        - name
        - type
        - description
      type: object
    Agents.Execution.AwaitingConfirmationPayload:
      properties:
        reason:
          type: string
      required:
        - reason
      type: object
    Agents.Execution.CancelledPayload:
      properties:
        reason:
          $ref: '#/components/schemas/Agents.Execution.CancelReason'
      required:
        - reason
      type: object
    Agents.Execution.CompletedPayload:
      properties:
        outcome:
          type: string
        reasoning:
          type: string
        result: {}
      required:
        - outcome
        - reasoning
        - result
      type: object
    Agents.Execution.FailedPayload:
      properties:
        os_error:
          $ref: '#/components/schemas/Common.OSError'
        reason:
          type: string
      required:
        - reason
      type: object
    Agents.Execution.PausedPayload:
      properties:
        question:
          $ref: '#/components/schemas/Agents.Execution.AskUserQuestion'
        reason:
          type: string
      required:
        - reason
      type: object
    Agents.Execution.Status:
      enum:
        - starting
        - running
        - paused
        - awaiting_confirmation
        - completed
        - cancelled
        - failed
        - paused_by_agent
      type: string
    Agents.Execution.Todo:
      properties:
        activeForm:
          type: string
        content:
          type: string
        status:
          $ref: '#/components/schemas/Agents.Execution.TodoStatus'
      required:
        - content
        - status
      type: object
    Agents.Execution.NodeOutputItem:
      description: A single output variable with a name and value
      properties:
        name:
          description: The name of the output variable
          type: string
        value:
          description: The value of the output variable
          type: string
      required:
        - name
        - value
      type: object
    Agents.Graph.Models.Transitions.TransitionType:
      enum:
        - iris
        - selector
        - outcome_success
      type: string
    Agents.Execution.WorkflowUpdate:
      properties:
        nodeDetails:
          $ref: '#/components/schemas/Agents.Execution.NodeDetails'
        rulesDetails:
          $ref: '#/components/schemas/Agents.Execution.RulesDetails'
        transitionDetails:
          $ref: '#/components/schemas/Agents.Execution.TransitionDetails'
        updateType:
          $ref: '#/components/schemas/Agents.Execution.UpdateType'
      required:
        - updateType
      type: object
    Agents.Execution.ActivityPresentationLevel:
      enum:
        - primary
        - secondary
        - system
      type: string
    Agents.Execution.AgentQueryContextCompletedDetails:
      properties:
        actionName:
          enum:
            - agent_query_context
          type: string
        answer:
          type: string
        query:
          type: string
      required:
        - actionName
        - query
        - answer
      type: object
    Agents.Execution.BrowserRunCodeCompletedDetails:
      properties:
        actionName:
          enum:
            - browser_run_code
          type: string
        consoleLogs:
          items:
            type: string
          type: array
        failedLine:
          type: integer
        result:
          type: string
        success:
          type: boolean
      required:
        - actionName
        - success
        - result
        - consoleLogs
      type: object
    Agents.Execution.ElementFileUploadCompletedDetails:
      properties:
        actionName:
          enum:
            - element_file_upload
          type: string
        fileNames:
          items:
            type: string
          type: array
      required:
        - actionName
        - fileNames
      type: object
    Agents.Execution.ExtApiCallCompletedDetails:
      properties:
        actionName:
          enum:
            - ext_api_call
          type: string
        requestMethod:
          type: string
        requestUrl:
          type: string
        responseBody:
          type: string
        statusCode:
          type: string
      required:
        - actionName
        - statusCode
        - responseBody
      type: object
    Agents.Execution.ExtGetMailCompletedDetails:
      properties:
        actionName:
          enum:
            - ext_get_mail
          type: string
        emailCount:
          format: int32
          type: integer
        emails:
          items: {}
          type: array
      required:
        - actionName
        - emailCount
        - emails
      type: object
    Agents.Execution.ExtSendMailCompletedDetails:
      properties:
        actionName:
          enum:
            - ext_send_mail
          type: string
        emailId:
          type: string
        success:
          type: boolean
      required:
        - actionName
        - success
      type: object
    Agents.Execution.FileListCompletedDetails:
      properties:
        actionName:
          enum:
            - file_list
          type: string
        fileNames:
          items:
            type: string
          type: array
      required:
        - actionName
        - fileNames
      type: object
    Agents.Execution.FileReadCompletedDetails:
      properties:
        actionName:
          enum:
            - file_read
          type: string
        errorCount:
          format: int32
          type: integer
        fileNames:
          items:
            type: string
          type: array
        totalSizeBytes:
          format: int64
          type: integer
      required:
        - actionName
        - fileNames
      type: object
    Agents.Execution.FileStageCompletedDetails:
      properties:
        actionName:
          enum:
            - file_stage
          type: string
        fileNames:
          items:
            type: string
          type: array
      required:
        - actionName
        - fileNames
      type: object
    Agents.Execution.HandoffPrepareCompletedDetails:
      properties:
        actionName:
          enum:
            - handoff_prepare
          type: string
        success:
          type: boolean
      required:
        - actionName
        - success
      type: object
    Agents.Execution.NavToCompletedDetails:
      properties:
        actionName:
          enum:
            - nav_to
          type: string
        pageTitle:
          type: string
      required:
        - actionName
      type: object
    Agents.Execution.ObsSnapshotWithSelectorsCompletedDetails:
      properties:
        actionName:
          enum:
            - obs_snapshot_with_selectors
          type: string
        title:
          type: string
        url:
          type: string
      required:
        - actionName
        - url
        - title
      type: object
    Agents.Execution.ReadFileCompletedDetails:
      properties:
        actionName:
          enum:
            - read_file
          type: string
        content:
          type: string
        contentType:
          enum:
            - image
            - document
            - text
            - unknown
          type: string
        mimeType:
          type: string
      required:
        - actionName
        - contentType
      type: object
    Agents.Execution.ScratchpadReadCompletedDetails:
      properties:
        actionName:
          enum:
            - scratchpad_read
          type: string
        content:
          type: string
        contentTruncated:
          type: boolean
      required:
        - actionName
      type: object
    Agents.Execution.ScratchpadWriteCompletedDetails:
      properties:
        actionName:
          enum:
            - scratchpad_write
          type: string
        content:
          type: string
        contentTruncated:
          type: boolean
        linesChanged:
          format: int32
          type: integer
        patchesApplied:
          format: int32
          type: integer
        totalLines:
          format: int32
          type: integer
      required:
        - actionName
        - linesChanged
        - totalLines
        - patchesApplied
      type: object
    Agents.Execution.ScriptEvalCompletedDetails:
      properties:
        actionName:
          enum:
            - script_eval
          type: string
        result: {}
      required:
        - actionName
        - result
      type: object
    Agents.Execution.ScriptHybridPlaywrightCompletedDetails:
      properties:
        actionName:
          enum:
            - script_hybrid_playwright
          type: string
        consoleLogs:
          items:
            type: string
          type: array
        failedLine:
          type: integer
        result:
          type: string
        success:
          type: boolean
      required:
        - actionName
        - success
        - result
        - consoleLogs
      type: object
    Agents.Execution.ScriptPlaywrightCompletedDetails:
      properties:
        actionName:
          enum:
            - script_playwright
          type: string
        consoleLogs:
          items:
            type: string
          type: array
        failedLine:
          type: integer
        result:
          type: string
        success:
          type: boolean
      required:
        - actionName
        - success
        - result
        - consoleLogs
      type: object
    Agents.Execution.ScriptpadReadCompletedDetails:
      properties:
        actionName:
          enum:
            - scriptpad_read
          type: string
        content:
          type: string
      required:
        - actionName
        - content
      type: object
    Agents.Execution.ScriptPadRunFunctionCompletedDetails:
      properties:
        actionName:
          enum:
            - scriptpad_run_function
          type: string
        consoleLogs:
          items:
            type: string
          type: array
        failedLine:
          type: integer
        result:
          type: string
        success:
          type: boolean
      required:
        - actionName
        - success
        - result
        - consoleLogs
      type: object
    Agents.Execution.ScriptpadSearchReplaceCompletedDetails:
      properties:
        actionName:
          enum:
            - scriptpad_search_replace
          type: string
        linesReplaced:
          type: integer
        linesReplacedWith:
          type: integer
        newScriptpad:
          type: string
        newTotalLines:
          type: integer
        oldScriptpad:
          type: string
        oldTotalLines:
          type: integer
      required:
        - actionName
        - linesReplaced
        - linesReplacedWith
        - oldTotalLines
        - newTotalLines
      type: object
    Agents.Execution.ScriptpadWriteCompletedDetails:
      properties:
        actionName:
          enum:
            - scriptpad_write
          type: string
        linesChanged:
          format: int32
          type: integer
        patchesApplied:
          format: int32
          type: integer
        scriptpad:
          type: string
        totalLines:
          format: int32
          type: integer
      required:
        - actionName
        - linesChanged
        - totalLines
        - patchesApplied
      type: object
    Agents.Execution.SdkBashCompletedDetails:
      properties:
        actionName:
          enum:
            - sdk_bash
          type: string
        exitCode:
          format: int32
          type: integer
        output:
          type: string
      required:
        - actionName
        - output
      type: object
    Agents.Execution.SdkEditCompletedDetails:
      properties:
        actionName:
          enum:
            - sdk_edit
          type: string
        success:
          type: boolean
      required:
        - actionName
        - success
      type: object
    Agents.Execution.SdkGlobCompletedDetails:
      properties:
        actionName:
          enum:
            - sdk_glob
          type: string
        files:
          items:
            type: string
          type: array
      required:
        - actionName
        - files
      type: object
    Agents.Execution.SdkGrepCompletedDetails:
      properties:
        actionName:
          enum:
            - sdk_grep
          type: string
        output:
          type: string
        outputMode:
          type: string
      required:
        - actionName
        - output
      type: object
    Agents.Execution.SdkReadCompletedDetails:
      properties:
        actionName:
          enum:
            - sdk_read
          type: string
        content:
          type: string
      required:
        - actionName
        - content
      type: object
    Agents.Execution.SdkWriteCompletedDetails:
      properties:
        actionName:
          enum:
            - sdk_write
          type: string
        success:
          type: boolean
      required:
        - actionName
        - success
      type: object
    Agents.Execution.UtilGetDatetimeCompletedDetails:
      properties:
        actionName:
          enum:
            - util_get_datetime
          type: string
        datetime:
          format: date-time
          type: string
        tzTimezoneIdentifier:
          type: string
        usedBrowserTimezone:
          type: boolean
      required:
        - actionName
        - usedBrowserTimezone
        - datetime
        - tzTimezoneIdentifier
      type: object
    Agents.Execution.AgentQueryContextStartedDetails:
      properties:
        actionName:
          enum:
            - agent_query_context
          type: string
        query:
          type: string
      required:
        - actionName
        - query
      type: object
    Agents.Execution.BrowserRunCodeStartedDetails:
      properties:
        actionName:
          enum:
            - browser_run_code
          type: string
        code:
          type: string
      required:
        - actionName
        - code
      type: object
    Agents.Execution.ExtSendMailStartedDetails:
      properties:
        actionName:
          enum:
            - ext_send_mail
          type: string
        bcc:
          items:
            type: string
          type: array
        bodyPreview:
          type: string
        cc:
          items:
            type: string
          type: array
        subject:
          type: string
        to:
          items:
            type: string
          type: array
      required:
        - actionName
        - to
        - subject
      type: object
    Agents.Execution.HandoffPrepareStartedDetails:
      properties:
        actionName:
          enum:
            - handoff_prepare
          type: string
        summary:
          type: string
        target:
          type: string
        variables:
          items:
            $ref: '#/components/schemas/Agents.Execution.HandoffPrepareVariable'
          type: array
      required:
        - actionName
      type: object
    Agents.Execution.LLMCallStartedDetails:
      properties:
        actionName:
          enum:
            - llm_call
          type: string
        purpose:
          $ref: '#/components/schemas/Agents.Execution.LLMCallPurpose'
      required:
        - actionName
        - purpose
      type: object
    Agents.Execution.NavToStartedDetails:
      properties:
        actionName:
          enum:
            - nav_to
          type: string
        url:
          type: string
      required:
        - actionName
        - url
      type: object
    Agents.Execution.ReadFileStartedDetails:
      properties:
        actionName:
          enum:
            - read_file
          type: string
        filePath:
          type: string
      required:
        - actionName
        - filePath
      type: object
    Agents.Execution.ScratchpadReadStartedDetails:
      properties:
        actionName:
          enum:
            - scratchpad_read
          type: string
        operation:
          enum:
            - read
          type: string
      required:
        - actionName
        - operation
      type: object
    Agents.Execution.ScratchpadWriteStartedDetails:
      properties:
        actionName:
          enum:
            - scratchpad_write
          type: string
        operation:
          enum:
            - write
          type: string
      required:
        - actionName
        - operation
      type: object
    Agents.Execution.ScriptEvalStartedDetails:
      properties:
        actionName:
          enum:
            - script_eval
          type: string
        element:
          type: string
        function:
          type: string
        ref:
          type: string
      required:
        - actionName
        - function
      type: object
    Agents.Execution.ScriptHybridPlaywrightStartedDetails:
      properties:
        actionName:
          enum:
            - script_hybrid_playwright
          type: string
        llmVars:
          items:
            type: string
          type: array
      required:
        - actionName
      type: object
    Agents.Execution.ScriptPlaywrightStartedDetails:
      properties:
        actionName:
          enum:
            - script_playwright
          type: string
        llmVars:
          items:
            type: string
          type: array
      required:
        - actionName
      type: object
    Agents.Execution.ScriptpadReadStartedDetails:
      properties:
        actionName:
          enum:
            - scriptpad_read
          type: string
        limit:
          type: integer
        offset:
          type: integer
      required:
        - actionName
        - offset
        - limit
      type: object
    Agents.Execution.ScriptpadRunFunctionStartedDetails:
      properties:
        actionName:
          enum:
            - scriptpad_run_function
          type: string
        arguments: {}
        functionName:
          type: string
      required:
        - actionName
        - functionName
        - arguments
      type: object
    Agents.Execution.ScriptpadSearchReplaceStartedDetails:
      properties:
        actionName:
          enum:
            - scriptpad_search_replace
          type: string
        replace:
          type: string
        replaceAll:
          type: boolean
        search:
          type: string
      required:
        - actionName
        - search
        - replace
        - replaceAll
      type: object
    Agents.Execution.SdkBashStartedDetails:
      properties:
        actionName:
          enum:
            - sdk_bash
          type: string
        command:
          type: string
        description:
          type: string
      required:
        - actionName
        - command
      type: object
    Agents.Execution.SdkEditStartedDetails:
      properties:
        actionName:
          enum:
            - sdk_edit
          type: string
        filePath:
          type: string
        newString:
          type: string
        oldString:
          type: string
        replaceAll:
          type: boolean
      required:
        - actionName
        - filePath
        - oldString
        - newString
      type: object
    Agents.Execution.SdkGlobStartedDetails:
      properties:
        actionName:
          enum:
            - sdk_glob
          type: string
        path:
          type: string
        pattern:
          type: string
      required:
        - actionName
        - pattern
      type: object
    Agents.Execution.SdkGrepStartedDetails:
      properties:
        actionName:
          enum:
            - sdk_grep
          type: string
        glob:
          type: string
        outputMode:
          type: string
        path:
          type: string
        pattern:
          type: string
      required:
        - actionName
        - pattern
      type: object
    Agents.Execution.SdkReadStartedDetails:
      properties:
        actionName:
          enum:
            - sdk_read
          type: string
        filePath:
          type: string
        limit:
          format: int32
          type: integer
        offset:
          format: int32
          type: integer
      required:
        - actionName
        - filePath
      type: object
    Agents.Execution.SdkWriteStartedDetails:
      properties:
        actionName:
          enum:
            - sdk_write
          type: string
        filePath:
          type: string
      required:
        - actionName
        - filePath
      type: object
    Agents.Execution.UtilGetDatetimeStartedDetails:
      properties:
        actionName:
          enum:
            - util_get_datetime
          type: string
        tzTimezoneIdentifier:
          type: string
      required:
        - actionName
        - tzTimezoneIdentifier
      type: object
    Agents.Graph.Models.Nodes.Properties.PlaywrightScriptLLMVarType:
      enum:
        - string
        - number
        - boolean
      type: string
    Agents.Execution.CancelReason:
      enum:
        - timeout
        - max_steps
        - user_requested
        - script_failed
      type: string
    Common.OSError:
      properties:
        message:
          type: string
      required:
        - message
      type: object
    Agents.Execution.AskUserQuestion:
      properties:
        questions:
          items:
            $ref: '#/components/schemas/Agents.Execution.QuestionItem'
          type: array
      required:
        - questions
      type: object
    Agents.Execution.TodoStatus:
      enum:
        - pending
        - in_progress
        - completed
      type: string
      x-enum-varnames:
        - TodoPending
        - TodoInProgress
        - TodoCompleted
    Agents.Execution.NodeDetails:
      properties:
        nodeID:
          $ref: '#/components/schemas/Common.uuid'
        nodeName:
          type: string
        nodeType:
          type: string
      required:
        - nodeID
        - nodeName
        - nodeType
      type: object
    Agents.Execution.RulesDetails:
      properties:
        rules:
          type: string
      required:
        - rules
      type: object
    Agents.Execution.TransitionDetails:
      properties:
        transitionID:
          $ref: '#/components/schemas/Common.uuid'
        transitionType:
          type: string
      required:
        - transitionID
        - transitionType
      type: object
    Agents.Execution.UpdateType:
      enum:
        - add
        - edit
        - delete
      type: string
    Agents.Execution.HandoffPrepareVariable:
      properties:
        name:
          type: string
        value:
          type: string
      required:
        - name
        - value
      type: object
    Agents.Execution.LLMCallPurpose:
      enum:
        - iris_pick_next_action
        - transition_pick_next_node
        - output_populate_result
        - generate_hybrid_playwright_code
        - generate_playwright_variables
      type: string
    Agents.Execution.QuestionItem:
      properties:
        header:
          type: string
        multiSelect:
          type: boolean
        options:
          items:
            $ref: '#/components/schemas/Agents.Execution.QuestionOption'
          type: array
        question:
          type: string
      required:
        - question
        - header
        - options
      type: object
    Agents.Execution.QuestionOption:
      properties:
        description:
          type: string
        label:
          type: string
      required:
        - label
        - description
      type: object
  securitySchemes:
    ApiKeyAuth:
      in: header
      name: X-Asteroid-Agents-Api-Key
      type: apiKey

````